using System;
using System.Data.OleDb;

namespace Shop.Common
{
    public enum ShopError
    {
        GenericError, // nunca devia ser usado! o erro deve ser explicito
        GenericDataError,
        DatabaseNotFound,
        SqlSintaxError,
        UnexistentId,
    }

    public class ShopException : Exception
    {
        private ShopError errorCode;

        public ShopError ErrorCode
        {
            get { return errorCode; }
        }

        public ShopException(OleDbException ex)
            : base(null, ex)
        {
            switch (ex.ErrorCode)
            {
                case -2147467259:
                    errorCode = ShopError.DatabaseNotFound;
                    break;
                case -2147217900:
                    errorCode = ShopError.SqlSintaxError;
                    break;
                default:
                    errorCode = ShopError.GenericDataError;
                    break;
            }
        }

        public ShopException(string msg, Exception ex)
            : base(msg, ex)
        {
            this.errorCode = ShopError.GenericError;
        }

        public ShopException(ShopError error, string msg) : base(msg)
        {
            this.errorCode = error;
        }
    }
}
