using System;
using System.Data;
using System.Data.OleDb;

namespace Shop.DAL
{
    public abstract class BaseGateway
    {
        public BaseGateway()
        {
        }

        public BaseGateway(TransactionalContext ctx)
        {
            tx = ctx;
        }

        private TransactionalContext tx;

        protected OleDbConnection GetConnection()
        {
            if (tx == null)
            {
                OleDbConnection conn = new OleDbConnection(CONN);
                conn.Open();
                return conn;
            }
            else
                return tx.Transaction.Connection;
        }

        protected void CloseConnection(OleDbConnection conn)
        {
            if (tx == null)
            {
                if (conn.State == ConnectionState.Open)
                    conn.Close();
            }
        }

        protected OleDbTransaction GetTransaction()
        {
            if (tx == null)
                return null;
            else
                return tx.Transaction;
        }

        private const string DEFAULT_CONN = @"Provider=Microsoft.Jet.OLEDB.4.0;User ID=;Password=;Mode=Share Deny None;Data Source=";
        private const string DEFAULT_DBPATH = @"C:\Documents and Settings\Paulo Sousa\My Documents\Actividade Lectiva\Disciplinas\ADAV\trab ref 2004-2005\ShopPAG\Sales.mdb";

        internal static string CONN
        {
            get
            {
                //return DEFAULT_CONN + DEFAULT_DBPATH; 
                return System.Configuration.ConfigurationSettings.AppSettings["BD"];
            }
        }
    }
}
