using System;
using System.Data;
using System.Data.OleDb;
using Shop.Common;

namespace Shop.DAL
{
    public class SaleDetailsGateway : BaseGateway
    {
        public SaleDetailsGateway() { }
        public SaleDetailsGateway(TransactionalContext tx) : base(tx) { }

        public int Insert(int saleID, int productID, int Quant, float totalCost)
        {
            OleDbConnection conn = null;

            try
            {
                // criar objecto de conexo  base de dados e abrir a conexo
                conn = GetConnection();

                throw new NotImplementedException();
            }
            catch (OleDbException ex)
            {
                // tratar a excepo!!!!
                System.Console.WriteLine("EXCEPO no mtodo 'Insert': " + ex.Message);
                //status = ShopStatus.DatabaseError;
                throw new ShopException(ex);
            }
            finally
            {
                // fechar a conexo
                CloseConnection(conn);
            }
        }

        public void Update(DataSet RsDetails)
        {
            OleDbConnection conn = null;

            try
            {
                // criar objecto de conexo  base de dados e abrir a conexo
                conn = GetConnection();

                // inserir linhas de detalhe
                OleDbDataAdapter da = new OleDbDataAdapter("SELECT * FROM SaleDetails", conn);
                da.SelectCommand.Transaction = GetTransaction();
                OleDbCommandBuilder cb = new OleDbCommandBuilder(da);
                da.Update(RsDetails, "SaleDetails");
            }
            catch (OleDbException ex)
            {
                // tratar a excepo!!!!
                System.Console.WriteLine("EXCEPO no mtodo 'Insert': " + ex.Message);
                //status = ShopStatus.DatabaseError;
                throw new ShopException(ex);
            }
            finally
            {
                // fechar a conexo
                CloseConnection(conn);
            }
        }

        public void FillByCustomer(int customerID, DataSet ds)
        {
            OleDbConnection conn = null;

            try
            {
                // criar objecto de conexo  base de dados e abrir a conexo
                conn = GetConnection();

                // criar um Datadapter para executar o comando e devolver o dataset
                // linhas de detalhe
                string sSqlCmd = "SELECT * FROM vwExpandedSaleDetails WHERE SaleId IN (SELECT SaleID FROM Sales WHERE CustomerId=?)";
                OleDbDataAdapter oAdapter = new OleDbDataAdapter(sSqlCmd, conn);
                oAdapter.SelectCommand.Parameters.Add("custid", customerID);
                oAdapter.SelectCommand.Transaction = GetTransaction();

                // executar o comando e preencher um Dataset
                oAdapter.Fill(ds, "SaleDetails");
            }
            catch (OleDbException ex)
            {
                // tratar a excepo!!!!
                System.Console.WriteLine("EXCEPO no mtodo 'GetByCustomer': " + ex.Message);
                //status = ShopStatus.DatabaseError;
                throw new ShopException(ex);
            }
            finally
            {
                // fechar a conexo
                CloseConnection(conn);
            }
        }

        public void FillByID(int id, DataSet ds)
        {
            OleDbConnection conn = null;

            try
            {
                // criar objecto de conexo  base de dados e abrir a conexo
                conn = GetConnection();

                // criar um Datadapter para executar o comando e devolver o dataset
                // linhas de detalhe
                string sSqlCmd = "SELECT * FROM vwExpandedSaleDetails WHERE SaleId=?";
                OleDbDataAdapter oAdapter = new OleDbDataAdapter(sSqlCmd, conn);
                oAdapter.SelectCommand.Parameters.Add("sid", id);
                oAdapter.SelectCommand.Transaction = GetTransaction();

                // executar o comando e preencher um Dataset
                oAdapter.Fill(ds, "SaleDetails");
            }
            catch (OleDbException ex)
            {
                // tratar a excepo!!!!
                System.Console.WriteLine("EXCEPO no mtodo 'GetSaleById': " + ex.Message);
                //status = ShopStatus.DatabaseError;
                throw new ShopException(ex);
            }
            finally
            {
                // fechar a conexo
                CloseConnection(conn);
            }
        }

        public void FillAll(DataSet ds)
        {
            OleDbConnection conn = null;

            try
            {
                // criar objecto de conexo  base de dados e abrir a conexo
                conn = GetConnection();

                // criar um Datadapter para executar o comando e devolver o dataset
                // linhas de detalhe
                string sSqlCmd = "Select * From vwExpandedSaleDetails";
                OleDbDataAdapter oAdapter = new OleDbDataAdapter(sSqlCmd, conn);
                oAdapter.SelectCommand.Transaction = GetTransaction();

                // executar o comando e preencher um Dataset
                oAdapter.Fill(ds, "SaleDetails");
            }
            catch (OleDbException ex)
            {
                // tratar a excepo!!!!
                System.Console.WriteLine("EXCEPO no mtodo 'GetAll': " + ex.Message);
                //status = ShopStatus.DatabaseError;
                throw new ShopException(ex);
            }
            finally
            {
                // fechar a conexo
                CloseConnection(conn);
            }
        }

        public DataSet GetByID(int p)
        {
            DataSet ds = new DataSet();
            FillByID(p, ds);
            return ds;
        }
    }
}
