using System;
using System.Data;
using System.Data.OleDb;
using Shop.Common;

namespace Shop.DAL
{
    public class UserGateway : BaseGateway
	{
        public UserGateway() { }
        public UserGateway(TransactionalContext tx) : base(tx) { }

		public DataSet GetByUsernameAndPassword(string user, string pass)
		{
            OleDbConnection conn = null;
			try
			{
                conn = GetConnection();
                OleDbDataAdapter da = new OleDbDataAdapter("SELECT * FROM Users WHERE User=? AND PASS=?", conn);
                da.SelectCommand.Parameters.AddWithValue("@un", user);
                da.SelectCommand.Parameters.AddWithValue("@p", pass);
                da.SelectCommand.Transaction = GetTransaction();
                DataSet ds = new DataSet();
                da.Fill(ds);
                return ds;
            }
			catch (OleDbException ex)
			{
				System.Console.WriteLine("EXCEPO no mtodo <ValidateAndGetUser> da classe 'User': " + ex.Message);
                throw new ShopException(ex);
			}
            finally
            {
                CloseConnection(conn);
            }
		}
	}
}
