using System;
using System.Data;
using System.Data.Common;
using System.Data.OleDb;

using Shop.Common;
namespace Shop.DAL
{
	internal class UtilDB
	{
		public static bool MayBeSqlInjection(string sqlFragment)
		{
			if (sqlFragment.IndexOf(';') > 0)
				return true;

			return false;
		}

		#region GetByID

		/// <summary>
		/// Obtem um dataset resultante de uma pesquisa por chave
		/// </summary>
		/// <param name="conn">a conexo a utilizar</param>
		/// <param name="table">tabela a pesquisar</param>
		/// <param name="keyName">campo chave a usar</param>
		/// <param name="key">valor da chave a pesquisar</param>
		/// <returns>um dataset do tipo pedido</returns>
		static public DataSet GetByID(OleDbConnection conn, OleDbTransaction tx, string table, string keyName, long key)
		{
			try
			{				
				DataSet ds = new DataSet();
				string sSqlCmd = "Select * From "+ table + " Where "+ keyName + " = "+ key.ToString();
				OleDbDataAdapter oAdapter = new OleDbDataAdapter(sSqlCmd, conn);
				oAdapter.SelectCommand.Transaction = tx;
				oAdapter.Fill(ds, table);
                return ds;
			}
			catch(OleDbException ex)
			{
				System.Console.WriteLine("EXCEPO no mtodo 'UtilDB.GetByID': " + ex.Message);
                throw new ShopException("UtilDB.GetById", ex);
			}
		}

		/// <summary>
		/// Obtem um dataset resultante de uma pesquisa por chave
		/// </summary>
		/// <param name="table">tabela a pesquisar</param>
		/// <param name="field">campo chave a usar</param>
		/// <param name="key">valor da chave a pesquisar</param>
		/// <returns>um dataset do tipo pedido</returns>
		static public DataSet GetByID(OleDbConnection conn, OleDbTransaction tx, string table, string keyName, int[] keys)
		{
			try
			{				
				DataSet ds = new DataSet();
				System.Text.StringBuilder sb = new System.Text.StringBuilder("Select * From "+ table + " Where "+ keyName + " IN (");
				foreach (int k in keys)
				{
					sb.Append(k.ToString());
					sb.Append(",");
				}
				sb.Length = sb.Length-1;
				sb.Append(")");
				string sSqlCmd = sb.ToString();

				OleDbDataAdapter oAdapter = new OleDbDataAdapter(sSqlCmd, conn);
				oAdapter.SelectCommand.Transaction = tx;
				oAdapter.Fill(ds, table);
                return ds;
			}
			catch(OleDbException ex)
			{
				System.Console.WriteLine("EXCEPO no mtodo 'UtilDB.GetByID': " + ex.Message);
                throw new ShopException("UtilDB.GetById", ex);
            }
		}
		
		#endregion

		#region FindByStringField

		/// <summary>
		/// Obtem um dataset resultante de uma pesquisa por chave
		/// </summary>
		/// <param name="table">tabela a pesquisar</param>
		/// <param name="field">campo chave a usar</param>
		/// <param name="key">valor da chave a pesquisar</param>
		/// <returns>um dataset do tipo pedido</returns>
		static public DataSet FindByStringField(OleDbConnection conn, string table, string field, string key)
		{
			
			try
			{
                DataSet ret = new DataSet();
				OleDbDataAdapter da = new OleDbDataAdapter("SELECT * FROM " + table + " WHERE " + field + " LIKE '" + key + "%'", conn);
				da.Fill(ret, table);
                return ret;
			}
			catch(OleDbException ex)
			{
				System.Console.WriteLine("EXCEPO no componente 'UtilDB': " + ex.Message);
                throw new ShopException("UtilDB.FindByStringField", ex);
            }
		}

		#endregion
	}
}
