/*************************************************************

(C) ISEP 2004
(C) Professores de ADAV 2004

O ISEP, na qualidade de autor do presente software, garante 
o direito de utilizao, alterao, evoluo e distribuio 
do mesmo sem qualquer tipo de restries, excepto:
	- esta mensagem no pode ser retirada
	- os nomes das classes no podem ser alterados

*************************************************************/

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using System.Data;
using Shop.BLL;
using Shop.Common;


namespace WinShop
{
	/// <summary>
	/// Summary description for PickCustomerForm.
	/// </summary>
	public class PickCustomerForm : BaseForm
	{
		private System.Windows.Forms.DataGrid dgCustomers;
		private System.Windows.Forms.Button btnSearch;
		private System.Windows.Forms.TextBox txtNamePattern;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public PickCustomerForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.dgCustomers = new System.Windows.Forms.DataGrid();
			this.btnSearch = new System.Windows.Forms.Button();
			this.txtNamePattern = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.btnOK = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.dgCustomers)).BeginInit();
			this.SuspendLayout();
			// 
			// dgCustomers
			// 
			this.dgCustomers.DataMember = "";
			this.dgCustomers.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dgCustomers.Location = new System.Drawing.Point(8, 112);
			this.dgCustomers.Name = "dgCustomers";
			this.dgCustomers.ReadOnly = true;
			this.dgCustomers.Size = new System.Drawing.Size(328, 136);
			this.dgCustomers.TabIndex = 20;
			// 
			// btnSearch
			// 
			this.btnSearch.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnSearch.Location = new System.Drawing.Point(256, 80);
			this.btnSearch.Name = "btnSearch";
			this.btnSearch.TabIndex = 19;
			this.btnSearch.Text = "Search";
			this.btnSearch.Click += new System.EventHandler(this.btnSearch_Click);
			// 
			// txtNamePattern
			// 
			this.txtNamePattern.Location = new System.Drawing.Point(56, 80);
			this.txtNamePattern.Name = "txtNamePattern";
			this.txtNamePattern.Size = new System.Drawing.Size(192, 20);
			this.txtNamePattern.TabIndex = 18;
			this.txtNamePattern.Text = "a%";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 80);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(48, 23);
			this.label1.TabIndex = 17;
			this.label1.Text = "Name:";
			// 
			// btnOK
			// 
			this.btnOK.Enabled = false;
			this.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnOK.Location = new System.Drawing.Point(82, 256);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 21;
			this.btnOK.Text = "OK";
			this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCancel.Location = new System.Drawing.Point(186, 256);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 22;
			this.btnCancel.Text = "Cancel";
			// 
			// PickCustomerForm
			// 
			this.AcceptButton = this.btnOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(342, 308);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.Controls.Add(this.dgCustomers);
			this.Controls.Add(this.btnSearch);
			this.Controls.Add(this.txtNamePattern);
			this.Controls.Add(this.label1);
			this.Name = "PickCustomerForm";
			this.Text = "Pick Customer";
			this.Controls.SetChildIndex(this.label1, 0);
			this.Controls.SetChildIndex(this.txtNamePattern, 0);
			this.Controls.SetChildIndex(this.btnSearch, 0);
			this.Controls.SetChildIndex(this.dgCustomers, 0);
			this.Controls.SetChildIndex(this.btnOK, 0);
			this.Controls.SetChildIndex(this.btnCancel, 0);
			((System.ComponentModel.ISupportInitialize)(this.dgCustomers)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void btnSearch_Click(object sender, System.EventArgs e)
		{
			if (txtNamePattern.Text.Trim().Length == 0)
				txtNamePattern.Text = "%";

			//
			// procurar os clientes
			//
			ICustomer c = new Customer();
			DataSet ds = c.FindByName(UserSettings.Username, UserSettings.Password, txtNamePattern.Text);
			
			//
			// esconder as colunas que no interessam
			//
			ds.Tables["Customers"].Columns["customerId"].ColumnMapping = MappingType.Hidden;
			ds.Tables["Customers"].Columns["PhoneNb"].ColumnMapping = MappingType.Hidden;
			ds.Tables["Customers"].Columns["FaxNb"].ColumnMapping = MappingType.Hidden;
			ds.Tables["Customers"].Columns["Email"].ColumnMapping = MappingType.Hidden;

			//
			// efectuar databind
			//
			dgCustomers.DataMember = "Customers";
			dgCustomers.DataSource = ds;

			//
			// permitir seleco
			//
			btnOK.Enabled = (ds.Tables["Customers"].Rows.Count != 0);
		}

		private int _customer;
		public int CustomerID
		{
			get { return _customer; }
		}

		private void btnOK_Click(object sender, System.EventArgs e)
		{
			if (dgCustomers.DataSource != null)
			{
				//
				// obter registo seleccionado na datagrid
				//

				//Get the Currency Manager by using the BindingContext of the DataGrid
				CurrencyManager cm = (CurrencyManager)this.BindingContext[dgCustomers.DataSource, dgCustomers.DataMember];

				//Retrieve the default DataView of the DataGrid
				DataView dv = (DataView)cm.List;

				// Use Currency Manager and DataView to retrieve the Current Row
				DataRow dr = dv[cm.Position].Row;

				this._customer = (int)dr["CustomerID"];

				this.DialogResult = DialogResult.OK;
			}
		
		}
	}
}
